<template>
  <section>
    <base-card>
      <h2>Submitted Experiences</h2>
      <div>
        <base-button @click="loadExperiences">Load Submitted Experiences</base-button>
      </div>
      <p v-if="isLoading">Loading...</p>
      <p v-else-if="!isLoading && error">
        {{ error }}
      </p>
      <p v-else-if="!isLoading && results?.length === 0">No stored experiences fround. Start adding some survey results first.</p>
      <ul v-else>
        <survey-result
          v-for="result in results"
          :key="result.id"
          :name="result.name"
          :rating="result.rating"
        ></survey-result>
      </ul>
    </base-card>
  </section>
</template>

<script>
import SurveyResult from './SurveyResult.vue';

const BASE_URL = process.env.VUE_APP_API_BASE_URL;

export default {
  // props: ['results'],
  components: {
    SurveyResult,
  },
  data() {
    return {
      results: [],
      isLoading: false,
      error: null,
    }
  },
  methods: {
    async loadExperiences() {
      this.isLoading = true;
      this.error = null;
      const surveys = await fetch(`${BASE_URL}/survey.json`).then(response => {
        if (response.ok) {
          return response.json(response.body)
        }
      }).catch(error => {
        console.log('ERROR: ', error);
        this.error = 'Failed to fetch data - please try again later.'
      });
      this.isLoading = false;
      this.results = [];
  
      for (const id in surveys) {
        this.results.push(
          {
            id,
            ...surveys[id]}
        );
      }
    }
  },
  mounted() {
    this.loadExperiences();
  }
};
</script>

<style scoped>
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}
</style>